#!/usr/bin/env python
from os import listdir
from os.path import isfile, join
import gzip
import re

t='_85_t6'
p= '0.15,0.85'

path="./sample_results"

# (1) get all the files
allfiles = [fname for fname in listdir(path) if isfile(join(path, fname))]
print "files:"+str(len(allfiles))

# (2) read each file and generate reopt for each seed
for filename in allfiles:

	print filename
	try: # GZIP file
		with gzip.open(join(path,filename)) as f:
    			content = f.readlines()
	except IOError: # ASCII file
		with open(join(path,filename)) as f:
			content = f.readlines()

	# (3) merge equivalent n,w,l inputs (do this by range w, otherwise to much memory)
	seeds = []
	for line in content:
		# get weight span length
		mo = re.match(r'^: .*\-n[ ][ ]*([0-9][0-9]*)[ ].*\-w[ ]*([0-9][0-9]*),[0-9][0-9]*[ ].*\-l[ ][ ]*([0-9][0-9]*)[ ].*$',line, re.M|re.I)
		if mo != None:
			# sidechain reopt each seed (local opt only)
			n = int(mo.group(1))
			w = int(mo.group(2))
			l = int(mo.group(3))
			for i,seed in enumerate(seeds):
				out_filename='input_sidechain_from_'+filename+'_n'+str(n)+'_w'+str(w)+'_l'+str(l)+'_'+t+"_"+i
				with open(out_filename,'w') as of:
					of.write("::CHECK: starting ...\n")
					s = str(int(w)+18)
					# FIXME use "p" for "-f parameter ?"
					of.write(": -spaced -BSymbols 01 -f "+p+" -b 0.5,0.5 -n " + str(n) + " -w " + str(w) + "," + str(w) + " -s " + str(w) + "," + str(s) +  " -l " + str(l) + " -p -r 10000 -k -m " + seed + "\n")
			seeds = []
		else:
			# memorize all the seeds before the ": commandline"
			mo2 = re.match(r'^(1[10,]*)[ \t].*$',line,re.M|re.I)
			if mo2 != None:
				seeds.append(mo2.group(1))
